package org.davic.mpeg.sections;

import org.openmhp.util.Out;

/**
* @author tejopa
* @date 13.2.2004
* @date 14.11.2004 constructor, getsource, docs
* @status partially implemented
* @module internal, mpeg sections

This class is used by TableSectionFilter to report that a section has been encountered which has a different version_number from earlier sections. It is generated only once per filtering action. The section with a different version_number is ignored.

*/
public class VersionChangeDetectedEvent extends SectionFilterEvent {

	public VersionChangeDetectedEvent(SectionFilter filter, Object appData)	{
		super(filter,appData);
		Out.printMe(Out.TRACE);
	}

	public Object getSource(){
		Out.printMe(Out.TRACE);
		return super.getSource();
	}

	public int getOriginalVersion()	{
		Out.printMe(Out.TODO,"returns 0");
		return 0;
	}

	public int getNewVersion(){
		Out.printMe(Out.TODO,"returns 0");
		return 0;
	}

}


