package org.davic.net.tuning;

import org.davic.mpeg.TransportStream;
import org.openmhp.util.*;

/**
* @author tejopa
* @date 13.2.2004
* @date 18.11.2004 partially implemented
* @status partially implemented
* @module TS, internal
*/
public class StreamTable {

    static LinkedList transportStreams;

	public StreamTable() {
		Out.printMe(Out.TRACE);
        transportStreams = new LinkedList();
	}

    /**
    Returns the transport streams that match the locator.

    The locator must uniquely identify the transport stream (i.e. for DVB networks, it must specify the orig_network_id and
    the transport_stream_id). If the locator is more specific than just identifying the transport stream, any more specific
    part of it will be disregarded.

    Since the same transport stream may be received via multiple networks and via multiple network interfaces, this function
    returns an array of all the possible transport stream objects that can be used for receiving this transport stream.

    Parameters:
        locator - A locator that points to a broadcast transport stream
    Returns:
        array of transport streams
    Throws:
        IncorrectLocatorException - raised if the locator does not reference a broadcast transport stream

    */
	public static TransportStream[] getTransportStreams(org.davic.net.Locator locator) throws NetworkInterfaceException {
		Out.printMe(Out.TRACE);
        LinkedList result = new LinkedList();
        for (int i=0;i<transportStreams.size();i++) {
            TransportStream curr = (TransportStream)transportStreams.get(i);
            //  CHECK ME
            //if (curr.getLocator().equals(locator)) {
            //    result.add(curr);
            //}
        }
        if (result.size()>0) {
            return (TransportStream[])result.getElements();
        }
		return null;
    }

	public static org.davic.net.Locator[] listTransportStreams() {
		Out.printMe(Out.TODO,"returns null");
		return null;
	}

}
