package org.dvb.dsmcc;

import java.io.*;
import org.openmhp.util.Out;

/**
* @author tejopa
* @date 12.2.2004
* @date 29.11.2004 docs
* @status partially implemented
* @module internal
*/
public class DSMCCStreamEvent extends DSMCCStream {

	/**
	Create a DSMCCStreamEvent from a DSMCCObject. The Object has to be a DSMCC
	StreamEvent.
	Parameters:
	aDSMCCObject - the DSMCC object which describes the stream.
	Throws:
	NotLoadedException - the DSMCCObject is not loaded.
	IllegalObjectTypeException - the DSMCCObject does not lead to a DSMCC
	StreamEvent.
	*/
	public DSMCCStreamEvent(DSMCCObject aDSMCCObject) throws NotLoadedException, IllegalObjectTypeException	{
		super(aDSMCCObject);
		Out.printMe(Out.TODO);
	}

	/**
	Create a DSMCCStreamEvent Object from its pathname. The path has to lead to a
	DSMCCStreamEvent.
	Parameters:
	path - the pathname of the DSMCCStreamEvent object
	Throws:
	IOException - An IO error has occurred.
	IllegalObjectTypeException - the path does not lead to a DSMCC StreamEvent.
	*/
	public DSMCCStreamEvent(String path) throws IOException, IllegalObjectTypeException	{
		super(path);
		Out.printMe(Out.TODO);
	}

	/**
	Create a DSMCCStreamEvent from its pathname. For an object Carousel, this method will block until
	the module which contains the object is loaded. The path has to lead to a DSMCC Stream Event
	Parameters:
	path - the directory path.
	name - the name of the DSMCCStreamEvent Object.
	Throws:
	IOException - If an IO error occurred.
	IllegalObjectTypeException - the path does not lead to a DSMCC StreamEvent.
	*/
	public DSMCCStreamEvent(String path, String name) throws IOException, IllegalObjectTypeException {
		super(path,name);
		Out.printMe(Out.TODO,"check from specs");
	}

	/**
	This function is used to subscribe to an event of a DSMCC StreamEvent object.
	Parameters:
	eventName - the name of the event.
	l - an object that implements the StreamEventListener Interface.
	Returns:
	The event Identi.er.
	Throws:
	UnknownEventException - the event cannot be found at this time
	InsufficientResourcesException - if resources needed to perform the subscription are
	not available
	*/
	public synchronized int subscribe(String eventName, StreamEventListener l) throws UnknownEventException, InsufficientResourcesException	{
		Out.printMe(Out.TODO,"returns -1");
		return -1;
	}

	/**
	This function is used to cancel the subscription to an event of a DSMCCEvent object.
	Parameters:
	eventId - Identi.er of the event.
	l - an object that implements the StreamEventListener Interface.
	Throws:
	UnknownEventException - The event can not be found.
	*/
	public synchronized void unsubscribe(int eventId, StreamEventListener l) throws UnknownEventException{
		Out.printMe(Out.TODO);
	}

	/**
	This function is used to cancel the subscription to an event of a DSMCCEvent object.
	Parameters:
	eventName - the name of the event.
	l - an object that implements the StreamEventListener Interface.
	Throws:
	UnknownEventException - The event can not be found.
	*/
	public synchronized void unsubscribe(String eventName, StreamEventListener l) throws UnknownEventException{
		Out.printMe(Out.TODO);
	}

	/**
	This function is used to get the list of the events of the DSMCCStreamEvent object.
	Returns:
	The list of the eventName.
	*/
	public String [] getEventList()	{
		Out.printMe(Out.TODO);
		return null;
	}

}

