package org.dvb.net.rc;

import org.davic.resources.*;
import java.io.IOException;

import org.openmhp.util.Out;

/**
* @author tejopa
* @date 11.2.2004
* @status not implemented
* @module return channel

This class models a connection based return channel network interface for use in receiving and
transmitting IP packets over a return channel. Targets for connections are speci?ed as strings including
the number to dial. These strings can only include numbers and are passed direct to the underlying
device.

IMPLEMENTED IN CATVRCInterface

*/
public class ConnectionRCInterface extends RCInterface implements ResourceProxy {



	protected ConnectionRCInterface(){	}

	public boolean isConnected() {
		Out.println(this,"isConnected");
		return false;
	}

	public float getSetupTimeEstimate()	{
		Out.println(this,"getSetupTimeEstimate");
		return 0.0f;
	}

	public void reserve(ResourceClient c, Object requestData) throws PermissionDeniedException {
		Out.println(this,"reserve");
	}

	public void release() {
		Out.println(this,"release");
	}

	public void connect() throws IOException, PermissionDeniedException {
		Out.println(this,"connect");
	}

	public void disconnect() throws PermissionDeniedException {
		Out.println(this,"disconnect");
	}

	public ConnectionParameters getCurrentTarget() throws IncompleteTargetException {
		Out.println(this,"getCurrentTarget");
		return null;
	}

	public void setTarget(ConnectionParameters target) throws IncompleteTargetException, PermissionDeniedException {
		Out.println(this,"setTarget");
	}

	public void setTargetToDefault() throws PermissionDeniedException {
		Out.println(this,"setTargetToDefault");
	}

	public int getConnectedTime() {
		Out.println(this,"getConnectedTime");
		return 0;
	}

	public ResourceClient getClient() {
		Out.println(this,"getClient");
		return null;
	}

	public void addConnectionListener(ConnectionListener l) {
		Out.println(this,"addConnectionListener");
	}

	public void removeConnectionListener(ConnectionListener l) {
		Out.println(this,"removeConnectionListener");
	}

}


