package org.dvb.si;

/**
* @author tejopa
* @date 7.3.2004
* @date 29.11.2004 docs
* @status not implemented
* @module internal
* @HOME

Object instances of this class represent SI retrieval requests made by the application. The application
may cancel the request using this object.

*/
public class SIRequest{

    protected SIRequest() { }

	/**
	Returns whether the information will be returned from cache or from the stream
	Returns:
	true if the information will be returned from cache, false if the information will be retrieved from
	the stream
	*/
    public boolean isAvailableInCache() {
    	return true;
    }

	/**
	Cancels the retrieval request.
	Returns:
	true if the request was cancelled and an SIRequestCancelledEvent will be delivered to the
	listener, false if the request has already completed (either successfully, with an error or due to a
	prior cancel method call)
	*/
    public boolean cancelRequest() {
    	return true;
    }
}