package org.havi.ui;

import java.awt.Image;
import org.openmhp.util.LinkedList;
import org.openmhp.util.Out;


/**
 * @author tejopa
 * @date 6.3.2004
 * @status partially implemented
 * @module internal
 * HOME
 */
public class HIcon extends HStaticIcon implements HNavigable {
    
    private static HLook defaultHLook    = new HGraphicLook();
    private HLook look;
    private HSound gainFocusSound;
    private HSound loseFocusSound;
    private LinkedList listeners;
    
    public HIcon(){
        Out.printMe(Out.TRACE);
    }
    
    public HIcon(Image image){
        super(image);
        Out.printMe(Out.TODO);
    }
    
    public HIcon(Image image, int x, int y, int width, int height){
        super(image, x, y, width, height);
        Out.printMe(Out.TODO);
    }
    
    public HIcon(Image imageNormal, Image imageFocus, int x, int y, int width, int height){
        super(imageNormal, x, y, width, height);
        super.setGraphicContent(imageFocus, HVisible.FOCUSED_STATE);
        Out.printMe(Out.TODO);
    }
    
    public static void setDefaultLook(HGraphicLook hGraphicLook){
        defaultHLook = hGraphicLook;
        Out.printMe(Out.TODO);
    }
    
    public static HGraphicLook getDefaultLook(){
        Out.printMe(Out.TODO);
        return (HGraphicLook)defaultHLook;
    }
    
    public void setMove(int keyCode, HNavigable target){
        Out.printMe(Out.TODO);
    }
    
    public HNavigable getMove(int keyCode){
        Out.printMe(Out.TODO);
        return null;
    }
    
    public void setFocusTraversal(HNavigable up, HNavigable down, HNavigable left, HNavigable right){
        Out.printMe(Out.TODO);
    }
    
    public boolean isSelected(){
        Out.printMe(Out.TODO);
        return false;
    }
    
    public void setGainFocusSound(HSound sound){
        gainFocusSound = sound;
    }
    
    public void setLoseFocusSound(HSound sound){
        loseFocusSound = sound;
    }
    
    public HSound getGainFocusSound(){
        return gainFocusSound;
    }
    
    public HSound getLoseFocusSound(){
        return loseFocusSound;
    }
    
    public void addHFocusListener(org.havi.ui.event.HFocusListener l){
        if (listeners==null) { listeners = new LinkedList(); }
        listeners.add(l);
    }
    
    public void removeHFocusListener(org.havi.ui.event.HFocusListener l){
        if (listeners!=null) {
            listeners.remove(l);
        }
    }
    
    public int[] getNavigationKeys(){
        Out.printMe(Out.TODO);
        return(null);
    }
    
    public void processHFocusEvent(org.havi.ui.event.HFocusEvent evt){
        Out.printMe(Out.TODO);
    }
}
