package org.havi.ui;

import org.openmhp.util.Out;
import java.io.*;
import javax.media.*;
import java.net.*;

import org.openmhp.adaptation.havi.*;

/**
* @author tejopa
* @date 5.3.2004
* @date 14.4.2004 fully implemented
* @status fully implemented
* @module org.openmhp.adaptation.havi.HSoundImpl
* 
* The implementation of this class is moved entirely to the adaptation layer.
* The control of audio functionalities is so dependent on the platform, that
* I decided the whole class should be implemented independently for each platform.
*
*/
public class HSound extends java.lang.Object {

	static HSoundImpl actualHSound = null;

	public HSound(){
		Out.printMe(Out.TRACE);     
    	actualHSound = new HSoundImpl();
    }
    
    public void load(String location) throws java.io.IOException, java.lang.SecurityException{
		actualHSound.load(location);
    }

    public void load(java.net.URL contents) throws java.io.IOException, java.lang.SecurityException{
		Out.printMe(Out.TRACE);
		actualHSound.load(contents);	
    }

    public void set(byte[] data){
		Out.printMe(Out.TRACE);   
		actualHSound.set(data); 	
    }

    public void play(){
		Out.printMe(Out.TRACE);     	
		actualHSound.play(); 	
    }

    public void stop(){
    	Out.printMe(Out.TRACE);     	
		actualHSound.stop(); 	
    }

    public void loop(){
		Out.printMe(Out.TRACE);
		actualHSound.loop(); 	
    }

    public void dispose(){
		Out.printMe(Out.TRACE);
		actualHSound.dispose(); 	
    }
    
}
