package org.havi.ui.event;

import org.openmhp.util.Out;

/**
* @author tejopa
* @date 13.2.2004
* @status fully implemented
* @module internal
*/
public class HFocusEvent extends java.awt.event.FocusEvent {

    public static final int HFOCUS_FIRST   = 2025;
    public static final int FOCUS_TRANSFER = 2025;
    public static final int HFOCUS_LAST    = 2025;
    public static final int NO_TRANSFER_ID = -1;

    private int transferId;

    public HFocusEvent(java.awt.Component source, int id){
        super(source, id, false);
		Out.printMe(Out.TRACE);
    }

    public HFocusEvent(java.awt.Component source, int id, int tid){
        super(source, id, false);
        transferId = tid;
		Out.printMe(Out.TRACE);
    }

	/*
	Returns:
	an implementation specific value. The HAVi UI does not use temporary focus events and
	interoperable applications shall not call this method.
	*/
    public boolean isTemporary(){
		Out.printMe(Out.TRACE);
        return false;
    }

    public int getTransferId(){
		Out.printMe(Out.TRACE);
        return transferId;
    }

}
