package org.openmhp.service;

import org.openmhp.xlet.*;
import org.openmhp.system.*;

import org.openmhp.media.*;

import javax.tv.locator.Locator;
import javax.tv.service.*;
import javax.tv.service.selection.*;
import org.davic.net.dvb.*;

import org.openmhp.si.*;
import java.util.Vector;
import java.awt.*;

import org.openmhp.util.Out;

/**
* @author tejopa
* @date 17.3.2004
* @date 10.9.2004 added SubtitlingLanguageControl,  tejopa
* @status partially implemented
* @module internal, service
* @TODO returns fixed service number (third service from the file static/services.txt)
*/
public class ServiceContextImpl implements ServiceContext  {

	SIServiceImpl siservice = new SIServiceImpl();
	Vector listeners;

    private static ServiceContextImpl instance;

    private ServiceContextImpl()    {
    	Out.printMe(Out.TRACE);
    	siservice = (SIServiceImpl)SIDataEmulation.getSIServices().get(3);
    	listeners = new Vector();
    }


    public ServiceContentHandler[] getServiceContentHandlers() throws SecurityException    {
    	Out.printMe(Out.TRACE);
        ServiceContentHandler sch[] = new ServiceContentHandler[2];
        sch[0] = (ServiceContentHandler)MHPDevice.getVideoLayer().getPlayer();
        sch[1] = (ServiceContentHandler)SubtitlingLanguageControlImpl.getInstance();
		return sch;
    }

    public void addListener(ServiceContextListener servicecontextlistener)    {
    	Out.printMe(Out.TRACE,"added "+servicecontextlistener.toString());
		listeners.add(servicecontextlistener);
    }

    public void removeListener(ServiceContextListener servicecontextlistener)    {
    	Out.printMe(Out.TRACE);
		listeners.remove(servicecontextlistener);
    }

    public void select(Service service)    {
    	Out.printMe(Out.TODO);
    }

    public void select(Locator alocator[])    {
    	Out.printMe(Out.TODO);
    }

    public void stop()    {
    	Out.printMe(Out.TODO);
    }

    public void destroy()    {
    	Out.printMe(Out.TODO);
    }

    public Service getService()    {
    	Out.printMe(Out.TODO);
        return (Service)SIDataEmulation.getServices().get(2);
		//return instance;
    }

    public static ServiceContext getInstance()    {
        Out.printMe(Out.TRACE);
        if (instance==null)  instance = new ServiceContextImpl();

        return instance;
    }

}